if (window.MailView == null) {

  (function(doc, proto) {
    try { // check if browser supports :scope natively
      doc.querySelector(':scope body');
    } catch (err) { // polyfill native methods if it doesn't
      ['querySelector', 'querySelectorAll'].forEach(function(method) {
        var nativ = proto[method];
        proto[method] = function(selectors) {
          if (/(^|,)\s*:scope/.test(selectors)) { // only if selectors contains :scope
            var id = this.id; // remember current element id
            this.id = 'ID_' + new Date().getTime(); // assign new unique id
            selectors = selectors.replace(/((^|,)\s*):scope/g, '$1#' + this.id); // replace :scope with #ID
            var result = doc[method](selectors);
            this.id = id; // restore previous id
            return result;
          } else {
            return nativ.call(this, selectors); // use native code for other selectors
          }
        }
      });
    }
  })(window.document, Element.prototype);

  // var getAttrValue = function (val) {
  //   if (isNaN(val) == false) {
  //     val = val + 'px';
  //   }

  //   val = val.replace(/\s/g, '');
  //   return val;
  // }

  // css value를 parsing - 숫자 + 단위로 구분.
  var getCSSProp = function (str, isAttr) {
    var matchList = str.match(/^(-{0,1}\d+[.]*\d*|\d*[.]*\d+)/);
    if (matchList != null && matchList.length > 0) {
      var numStr = matchList[0];
      var unit = str.substring(numStr.length);
      var num = 0;
      if (numStr.indexOf('.') > -1) {
        num = parseFloat(numStr);
      } else {
        num = parseInt(numStr);
      }
      switch (unit) {
        case 'pt':
          num = num * 4 / 3;
          unit = 'px';
          break;
        case 'in':
          num = num * 96;
          unit = 'px';
          break;
        case 'pc':
          num = num * 16;
          unit = 'px';
          break;
        case 'cm':
          num = num * 37.79;
          unit = 'px';
          break;
        case 'mm':
          num = num * 3.779;
          unit = 'px';
          break;
      }
      if (isAttr == true && unit == '') {
        unit = 'px';
      }
      return {
        type: 1, // 숫자 + 단위.
        number: num,
        unit: (unit.length == 0) ? 'px': unit,
        realUnit: unit,
        isRel: (unit != 'px'), // 'px', 'pt' 이외의 단위는 상대적인 값으로 간주함.
        value: str
      };
    }
    return {
      type: 0, // 기타 값.
      value: str
    };
  }

  // // class 이름을 규격에 맞게 변환.
  // var getClassName = function (str) {
  //   var clsName = str.replace(/%/g, 'percent');
  //   clsName = clsName.replace(/[.]/g, '_');
  //   return clsName;
  // }

  // var findParent = function (elem, tagName) {
  //   var tmp = elem.parentElement;
  //   while(tmp != null && tmp.tagName !== tagName.toUpperCase()) {
  //     tmp = tmp.parentElement;
  //   }
  //   return tmp;
  // }

  var printLog = function () {
    console.log.apply(console, arguments);
  }

  // var getPropInfo = function (elem, propName, chkAttr) {
  //   if (elem.nfInfo != null && elem.nfInfo.propList.indexOf(propName) > -1) { // 이미 처리된 속성
  //     var prevVal = null;
  //     var isPrevEmpty = true;
  //     var isPrevImportant = false;
  //     if (elem.nfInfo.data[propName] != null) {
  //       prevVal = elem.nfInfo.data[propName].value;
  //       isPrevEmpty = elem.nfInfo.data[propName].isEmpty;
  //       isPrevImportant = elem.nfInfo.data[propName].isImportant;
  //     }
  //     return {
  //       propName: propName,
  //       element: elem,
  //       value: prevVal,
  //       isImportant: isPrevImportant,
  //       isEmpty: isPrevEmpty,
  //       chkAttr: chkAttr
  //     };
  //   }
  //   var val = elem.style.getPropertyValue(propName);
  //   var isImportant = (elem.style.getPropertyPriority(propName).length > 0);

  //   if (chkAttr == true && val == null || val.length == 0) {
  //     val = elem.getAttribute(propName);
  //     isImportant = false;
  //     if (val != null) {
  //       val = getAttrValue(val);
  //     }
  //   }

  //   return {
  //     propName: propName,
  //     element: elem,
  //     value: val,
  //     isImportant: isImportant,
  //     isEmpty: (val == null || val.length == 0),
  //     chkAttr: chkAttr
  //   };
  // }

  // if (window.CSSProp == undefined) {
  //   var maxWidth = 0;
  //   var maxWidth2 = 0;
  //   var maxWidth3 = 0;

  //   var widthLimit = 1024;

  //   // width 중에서 최대값.
  //   var getMaxWidth = function () {
  //     return maxWidth;
  //   }

  //   // 1024보다 작은 width 중에서 최대값.
  //   var getMaxWidth2 = function() {
  //     return maxWidth2;
  //   }

  //   // 1024보다 작은 width 중에서 최대값. - max-width 포함.
  //   var getMaxWidth3 = function() {
  //     return maxWidth3;
  //   }

  //   window.CSSProp = function(propName, valStr, smStr, isImportant, isAttr) {
  //     var self = this;
  //     self.name = propName;
  //     self.val = (typeof(valStr) == 'string') ? getCSSProp(valStr) : valStr;
  //     self.priority = isImportant;
  //     self.isAttr = isAttr;
  //     if (smStr == null) {
  //       self.smVal = (typeof(valStr) == 'string') ? getCSSProp(valStr) : valStr;
  //     } else {
  //       self.smVal = (typeof(smStr) == 'string') ? getCSSProp(smStr) : smStr;
  //     }
  //     self.smPriority = isImportant;

  //     if ((self.name == 'width' || self.name == 'min-width') && self.val.isRel == false) {
  //       printLog('-- width : ',self.name , self.val.number);
  //       if (maxWidth < self.val.number) {
  //         maxWidth = self.val.number;
  //       }
  //       if (self.val.number <= widthLimit && maxWidth2 < self.val.number) {
  //         maxWidth2 = self.val.number
  //       }
  //     }

  //     if ((self.name == 'max-width') && self.priority == true && self.val.isRel == false) {
  //       printLog('-- max-width : ',self.name , self.val.number);
  //       if (maxWidth < self.val.number) {
  //         maxWidth = self.val.number;
  //       }
  //       if (self.val.number <= widthLimit && maxWidth2 < self.val.number) {
  //         maxWidth2 = self.val.number
  //       }
  //     }

  //     if ((self.name == 'width' || self.name == 'min-width' || self.name == 'max-width') && self.val.isRel == false) {
  //       printLog('-- width3 : ',self.name , self.val.number);
  //       if (self.val.number <= widthLimit && maxWidth3 < self.val.number) {
  //         maxWidth3 = self.val.number
  //       }
  //     }
  //   }

  //   // attr 이 항상 false가 됨. (attr만 존재하는 속성은 없는 걸로 보임.)
  //   window.CSSProp.makeValue = function(propName, valStr, smStr, isImportant, isAttr) {
  //     return new CSSProp(propName, valStr, smStr, isImportant, isAttr);
  //   }
  // }

  var MailView = function(doc, nfCallback) {
    var self = this;

    self.state = -1;

    self.partialZoomMode = false;
    self.smartViewMode = false;

    self.nfCallback = nfCallback;

    self.options = {};

    self.doc = doc;

    // self.wTable = [];
    // self.wTableNormal = [];
    // self.bqList = [];
    // self.bqMap = {};

    // self.nfElems = [];
    // self.nfElemsNormal = [];

    // var pxLimit = 60;
    // var screenWidth = 300; // 300?

    // // calc(100vm - 16px)
    // var vwMax = 100; //100
    // var paddingMax = 16; // 16
    // var screenAvailWidth = window.screen.availWidth;

    // printLog('screen width1 - ', window.innerWidth, window.screen.availWidth, document.documentElement.offsetWidth);

    self.checkMediaQuery = function () {
      var i = 0, j = 0;
      var styleElems = self.doc.querySelectorAll('style');

      for(i = 0; i < styleElems.length; i++) {
        var sheet = styleElems[i].sheet;
        for (j = 0; j < sheet.rules.length; j++) {
          if (sheet.rules[j].type == 4) {
            return true;
          }
        }
      }
      return false;
    }

    self.isMediaQuery = self.checkMediaQuery();

    self.hasMediaQuery = function() {
      return self.isMediaQuery;
    };

    self.checkHScroll = function () {
      // 가로방향 스크롤이 필요한지 검사.
      return (self.doc.documentElement.offsetWidth < self.doc.documentElement.scrollWidth);
    }

    self.isHScroll = false;
    self.optimizeEnabled = false;

    self.hasHScroll = function() {
      self.isHScroll = self.checkHScroll();
      if (self.optimizeEnabled == false && self.isHScroll == true) {
        self.optimizeEnabled = true;
        if (self.isOnReadyCalled == true) {
          // optimize가 불가능했다가 가능해진 경우 호출됨. (예를 들면, 이미지 로딩 후)
          console.log(' --- onOptimizeEnable');
          self.colorMgr.nativeCall('onOptimizeEnable', null, []);
        }
      }
      return self.isHScroll;
    };

    self.setOptions = function (options) {
      self.options = options;

      if (self.options.mode == 'normal') {
        self.setOptimized(false);
      } else if (self.options.mode == 'optimized') {
        self.setOptimized(true);
      }
    };

    // var TAG = [
    //   'table',
    //   'img',
    //   'tr',
    //   'col',
    //   'td',
    //   'th',
    //   'hr',
    //   'ul',
    //   'ol',
    //   'blockquote'
    // ];

    // for(var i = 0; i < TAG.length; i++) {
    //   var tagName = TAG[i];
    //   var tagIDXName = tagName.toUpperCase();
    //   TAG[tagIDXName] = i;
    //   TAG[tagName] = i;
    // }
    // TAG.ETC = -1;

    // self.getTagIdx = function(str) {
    //   var name = str.toLowerCase();
    //   return TAG.indexOf(name);
    // }

    // var CONFIG = {
    //   MAX_TABLE_RESIZE_COLUMNS: 5
    // };

    self.setBodyVisible = function(val) {
      if (val == true) {
        if (window._bodyBgColor != null && self.isDarkMode() != true) {
          document.body.setAttribute('bgcolor', window._bodyBgColor);
        }
        self.doc.body.style.visibility = '';
      } else {
        self.doc.body.style.visibility = 'hidden';
      }
    };

    var createTag = function (tagText) {
      var divElem = document.createElement('div');
      divElem.innerHTML = tagText;
      return divElem.firstElementChild;
    }

    // var processMediaquery = function(value) {
    //   var i = 0;
    //   var styleElems = self.doc.querySelectorAll('style');

    //   for(i = 0; i < styleElems.length; i++) {
    //     if (value == true) {
    //       styleElems[i]._originCSS = '' + styleElems[i].textContent;
    //       var tmp = styleElems[i].textContent;
    //       tmp = tmp.replace(/max-device-width/gi, 'max-width');
    //       tmp = tmp.replace(/min-device-width/gi, 'min-width');
    //       styleElems[i].textContent = tmp;
    //     } else if (value == false && styleElems[i]._originCSS != null) {
    //       styleElems[i].textContent = srcElems[i]._originCSS;
    //     }
    //   }
    //   var srcElems = self.doc.querySelectorAll('source[media]');
    //   for(i = 0; i < srcElems.length; i++) {
    //     if (value == true) {
    //       srcElems[i]._originCSS = '' + srcElems[i].media;
    //       tmp = srcElems[i].media;
    //       tmp = tmp.replace(/max-device-width/gi, 'max-width');
    //       tmp = tmp.replace(/min-device-width/gi, 'min-width');
    //       srcElems[i].media = tmp;
    //     } else if (value == false && srcElems[i]._originCSS != null) {
    //       srcElems[i].media = srcElems[i]._originCSS;
    //     }
    //   }
    // };

    self.setViewMetaTag = function(value) {
      var i = 0;
      if (value === true) {
        self.oldMetaTags = self.doc.head.querySelectorAll('meta[name=viewport]');
        self.newMetaTag = createTag('<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=yes"/>');

        if (self.oldMetaTags.length > 0) {
          self.doc.head.insertBefore(self.newMetaTag, self.oldMetaTags[0]);
          for (i = 0; i < self.oldMetaTags.length; i++) {
            self.doc.head.removeChild(self.oldMetaTags[i]);
          }
        } else {
          self.doc.head.appendChild(self.newMetaTag);
        }
      } else if (value === false) {
        if (self.oldMetaTags.length > 0) {
          for (i = 0; i < self.oldMetaTags.length; i++) {
            self.doc.head.insertBefore(self.oldMetaTags[i], self.newMetaTag);
          }
        }
        self.doc.head.removeChild(self.newMetaTag);
      }

      printLog('screen width - ', window.innerWidth, window.screen.availWidth, document.documentElement.offsetWidth);
    };

    self.setIOSCSS = function() {
      var style = `
<style id="ios-css">
  div {
    height: auto;
  }
</style>
`;

      self.ios_css = createTag(style);
      self.doc.body.appendChild(self.ios_css);
    };

    self.setDefaultCSS = function() {
      var style = `
<style id="default-css">
  * {
    overflow-wrap: break-word;
  }
</style>
`;

      self.default_css = createTag(style);
      self.doc.head.appendChild(self.default_css);

      var messageContent = document.querySelector('body > .mail-message > .mail-message-content');

      if (messageContent == null) {
        self.setIOSCSS();
      }
    };

    self.checkEditableElem = function() {
      var editableElems = document.querySelectorAll('[contenteditable]');
      for (i = 0; i < editableElems.length; i++) {
        if (editableElems[i].getAttribute('contenteditable') === 'true') {
          editableElems[i].removeAttribute('contenteditable');
        }
      }
    };

    /* smart view module - start */

    /* smart view module - end */

    var removePartialZoom = function (elem, removeImgEvent, isCopy) {
      var container = elem || self.doc;

      if (elem == null) {
        // body width 복원.
        var bInfo = self.originBodyInfo;
        if (bInfo.width.length > 0) {
          bInfo.elem.style.setProperty('width', bInfo.width, bInfo.widthPriority);
        } else {
          bInfo.elem.style.removeProperty('width');
        }
        if (bInfo.minWidth.length > 0) {
          bInfo.elem.style.setProperty('min-width', bInfo.minWidth, bInfo.minWidthPriority);
        } else {
          bInfo.elem.style.removeProperty('min-width');
        }
      }

      var removeZoomAttr = function(node) {
        var attr = node.getAttribute('data-nine-zoom-style');
        if (attr != null && attr.length > 0) {
          node.setAttribute('style', attr);
        } else {
          node.removeAttribute('style');
        }
        node.removeAttribute('data-nine-zoom-style');
      };

      if (container != self.doc && container.getAttribute('data-nine-zoom-style') != null) {
        removeZoomAttr(container);
      } else {
        var attrElems = container.querySelectorAll('[data-nine-zoom-style]');
        var i = 0;
        for (i = 0; i < attrElems.length; i++) {
          removeZoomAttr(attrElems[i]);
        }
      }

      var ret = null;

      var removeWrapper = function(node) {
        // 2depth 아래의 노드를 가져옴.
        while (node.firstElementChild.children.length > 0) {
          ret = node.firstElementChild.firstElementChild;
          node.parentElement.insertBefore(ret, node);
        }
        node.parentElement.removeChild(node);
      };

      if (container != self.doc && container.classList.contains('nf-zoom-container') === true) {
        removeWrapper(container);
      } else if (container != self.doc && container.getAttribute('data-nine-zoom-elem') != null) {
        if (container.parentElement.classList.contains('nf-zoom-wrapper') === true ) {
          removeWrapper(container.parentElement.parentElement);
        } else {
          ret = container;
        }
      } else {
        var elems = container.querySelectorAll('.nf-zoom-container');
        for (i = 0; i < elems.length; i++) {
          removeWrapper(elems[i]);
        }
        elems = container.querySelectorAll('.nf-zoom-wrapper'); // copy 시 일부 노드에 남아있을 수 있는 wrapper 제거.
        for (i = 0; i < elems.length; i++) {
          // 1depth 아래의 노드를 가져옴.
          while (node.children.length > 0) {
            ret = node.firstElementChild;
            node.parentElement.insertBefore(ret, node);
          }
          node.parentElement.removeChild(node);
        }
      }

      if (container == self.doc || isCopy == true) {
        var tmpElems = container.querySelectorAll('[data-nine-zoom-elem]');
        for (i = 0; i < tmpElems.length; i++) {
          tmpElems[i].removeAttribute('data-nine-zoom-elem');
        }
      }

      if (removeImgEvent !== false) {
        var imgTags = document.body.querySelectorAll('img');
        for (i = 0; i < imgTags.length; i++) {
          imgTags[i].removeEventListener('load', imgTags[i].imgListener);
          imgTags[i].removeEventListener('error', imgTags[i].imgListener);
        }
      }

      return ret;
    };

    // 외부 호출을 위해 추가. Android(Kolon) copy에서 사용.
    self.removePartialZoom = removePartialZoom;

    var applyPartialZoom = function () {
      // body 바로 밑의 element들에 대해서, scrollWidth값을 통해 스크롤이 발생하는 element인지를 검사.
      // scale 조정을 통해 스크롤이 일어나지 않도록 크기 조절.
      var bodyElem = document.querySelector('body > .mail-message > .mail-message-content') || document.body;
      var marginLeft = window.getComputedStyle(bodyElem, null).marginLeft;
      marginLeft = getCSSProp(marginLeft);
      var marginRight = window.getComputedStyle(bodyElem, null).marginRight;
      marginRight = getCSSProp(marginRight);

      var lMargin = 0;
      var rMargin = 0;
      if (marginLeft.type == 1) {
        lMargin += marginLeft.number;
      }
      if (marginRight.type == 1) {
        rMargin += marginRight.number;
      }

      // body width가 화면 폭에 맞도록 조정.
      self.originBodyInfo = {
        elem: bodyElem,
        width: bodyElem.style.width,
        widthPriority: bodyElem.style.getPropertyPriority('width'),
        minWidth: bodyElem.style.minWidth,
        minWidthPriority: bodyElem.style.getPropertyPriority('min-width'),
      };

      bodyElem.style.setProperty('width', 'calc(100% - ' + (lMargin + rMargin) + 'px)', 'important');
      bodyElem.style.setProperty('min-width', 'unset',  'important');

      var bodyRect = bodyElem.getBoundingClientRect();
      var fullWidth = bodyRect.left + bodyRect.width; //document.documentElement.offsetWidth - (lMargin + rMargin);

      var bodyWidth = fullWidth - bodyRect.left; // window.screen.availWidth;

      console.log('partial zoom - ', bodyWidth, marginLeft, marginRight);

      var applyZoom = function(elem) {
        var oldRect = elem.getBoundingClientRect();
        var availWidth = fullWidth - oldRect.left;

        // scrollWidth가 0이거나, 이미 zoom이 적용된 element는 zoom을 적용하지 않는다.
        if (elem.scrollWidth === 0 || elem.scrollWidth < availWidth - 10 || elem.parentElement.classList.contains('nf-zoom-wrapper') === true) {
          return;
        }

        var curWidth = elem.offsetWidth;

        elem.setAttribute('data-nine-zoom-elem', 'true');
        var container = createTag('<div class="nf-zoom-container"></div>');
        var wrapper = createTag('<div class="nf-zoom-wrapper"></div>');
        container.appendChild(wrapper);
        elem.parentElement.insertBefore(container, elem);
        wrapper.appendChild(elem);

        var curTmp = container.parentElement;

        // curTmp.offsetWidth == 0를 이용하여 inline을 검사하는 경우, safari의 a태그는 1을 return하므로 문제가 발생함. (android도 유사한 경우 발생.)
        // getComputedStyle을 이용하여 inline을 검사하면 정상동작함.
        // while (curTmp.parentElement != body && curTmp.parentElement != null && curTmp.offsetWidth == 0) {
        while (curTmp.parentElement != bodyElem && curTmp.parentElement != null && window.getComputedStyle(curTmp, null).display == 'inline') {
          curTmp = curTmp.parentElement;
        }

        if (curTmp.offsetWidth > 0) {
          curWidth = curTmp.offsetWidth;
        }

        if (curWidth > 0) {
          availWidth = Math.min(curWidth, availWidth);
        }

        if (availWidth < (bodyWidth * 3 / 4)) {
          availWidth = bodyWidth * 3 / 4;
        }

        if (availWidth + oldRect.left > fullWidth) {
          availWidth = fullWidth - oldRect.left;
        }

        var realWidth = Math.max(oldRect.width, elem.scrollWidth);

        var ratio = availWidth / realWidth;

        console.log(' -- zoom', availWidth, oldRect.width, ratio, elem.scrollWidth);

        wrapper.style.transform = 'scale(' + ratio + ', ' + ratio + ')';
        var dir = window.getComputedStyle(wrapper, null).direction;
        if (dir == 'rtl') {
          wrapper.style.transformOrigin = 'right top';
        } else {
          wrapper.style.transformOrigin = 'left top';
        }
        container.style.width = availWidth + 'px';
        container.style.height = (oldRect.height * ratio) + 'px';
        // container.style.overflow = 'overlay';
        container.style.overflow = 'hidden';
        // elems[i].style.zoom = ratio;

        (function (itemElem, containerElem) {
          setTimeout(function() {
            var containerRect = containerElem.getBoundingClientRect();
            var checkCSSPosition = function(item) {
              if (item.getAttribute('data-nine-zoom-style') != null) {
                return;
              }
              var itemRect = item.getBoundingClientRect();
              if (itemRect.top < containerRect.top || itemRect.bottom > containerRect.bottom) {
                var oldStyle = item.getAttribute('style') || '';
                item.setAttribute('data-nine-zoom-style', oldStyle);
                item.style.position = 'static';
                item.style.margin = 'unset';
              } else {
                var elems = item.children;
                for (var i = 0; i < elems.length; i++) {
                  checkCSSPosition(elems[i]);
                }
              }
            };
            checkCSSPosition(itemElem);
          }, 10);
        })(elem, container);

        console.log(' -- body', document.documentElement.offsetWidth, bodyElem.scrollWidth);
      };

      var zoomCheck = function(elem) {
        if (elem.children.length > 0) {
          var elems = elem.children;

          for (var i = 0; i < elems.length; i++) {
            console.log(' -- ', i, bodyWidth, elems[i].scrollWidth);
            if (elems[i].scrollWidth === 0 || elems[i].scrollWidth > bodyWidth) {
              if (elems[i].offsetHeight > 0 && elems[i].scrollWidth > bodyWidth) {
                var width = window.getComputedStyle(elems[i], null).width;
                var widthProp = getCSSProp(width);
                var minWidth = window.getComputedStyle(elems[i], null).minWidth;
                var minWidthProp = getCSSProp(minWidth);
                if (widthProp.type == 1 || minWidthProp.type == 1) {
                  if (elems[i].offsetWidth > bodyWidth) {
                    applyZoom(elems[i]);
                    continue;
                  }
                }
              }
              var bound = elems[i].getBoundingClientRect();
              if (elems[i].classList.contains('nf-zoom-container') === false) {
                if (elems[i].offsetHeight > 0 && elem != bodyElem && bound.x > (bodyWidth / 4) && bound.right > bodyWidth && bound.width > 0) {
                  applyZoom(elem);
                } else if (elems[i].tagName === 'TABLE' || (elems[i].offsetHeight > 0 && elems[i].scrollWidth > 0 && elems[i].scrollWidth === elems[i].offsetWidth)) {
                  applyZoom(elems[i]);
                } else {
                  zoomCheck(elems[i]);
                }
              }
            }
          }
        } else {
          applyZoom(elem);
        }
      }

      var imgTags = bodyElem.querySelectorAll('img');
      self.zoomDelayTime = 500;
      if (imgTags.length > 5) {
        if (self.zoomDelayTimer != null) {
          clearTimeout(self.zoomDelayTimer);
        }
        self.zoomDelayTimer = setTimeout(function () {
          self.zoomDelayTime = 2500;
        }, 3000);
      }
      for (var i = 0; i < imgTags.length; i++) {
        var imgListener = function (e) {
          self.hasHScroll(); // 스크롤이 발생하는지 확인을 위해 호출 필요.
          // var tmp = e.target;
          // var tmpTop = tmp;
          // console.log('img onload - ', tmp);
          // var hasZoomParent = false;
          // while (tmp != null && tmp != bodyElem) {
          //   if (tmp.classList.contains('nf-zoom-container') === true || tmp.getAttribute('data-nine-zoom-elem') != null) {
          //     tmpTop = removePartialZoom(tmp, false);
          //     hasZoomParent = true;
          //     break;
          //   }
          //   if (tmp.parentElement != null && tmp.parentElement.querySelector('.nf-zoom-container, [data-nine-zoom-elem]') != null) {
          //     // sibling node 중에 zoom이 적용된 것이 있으면 더이상 상위로 올라가지 않는다.
          //     tmpTop = tmp;
          //     break;
          //   }
          //   tmp = tmp.parentElement;
          // }

          // if (hasZoomParent == false) {
          //   tmpTop = e.target;
          // }

          // (function (topElem) {
          //   setTimeout(function () {
          //     applyZoom(topElem);
          //   }, 10);
          // })(tmpTop);
          // 위의 방식으로는 이미지 상위의 태그에 width가 크게 존재하는 경우를 해결 못함. (table 등..)
          if ((Date.now() - self.lastNotiTime) > 5000) {
            self.zoomDelayTime = 500;
            self.zoomDelayTimer = setTimeout(function () {
              self.zoomDelayTime = 2500;
            }, 3000);
          }

          self.notifyResized(self.zoomDelayTime); // partial zoom을 해제했다가 다시 설정.
        };

        var imgElem = imgTags[i];
        var hasWidth = false;
        var hasHeight = false;
        var widthProp = null;
        var attrWidth = imgElem.getAttribute('width');
        if (attrWidth != null && attrWidth.trim().length > 0) {
          // hasWidth = true;
          widthProp = getCSSProp(imgElem.style.width, true);
        } else {
          widthProp = getCSSProp(imgElem.style.width);
        }
        if (widthProp.isRel == false && imgElem.offsetWidth >= widthProp.num) {
          hasWidth = true;
        }

        var attrHeight = imgElem.getAttribute('height');
        if (attrHeight != null && attrHeight.trim().length > 0) {
          hasHeight = true;
        } else {
          var heightProp = getCSSProp(imgElem.style.height);
          if (heightProp == false) {
            hasHeight = true;
          }
        }

        console.log(' -- image ', imgElem, hasWidth, hasHeight);

        // width, height가 모두 고정된 경우에는 다시 계산하지 않는다.
        if (hasWidth == false || hasHeight == false) {
          imgTags[i].imgListener = imgListener;
          imgTags[i].addEventListener('load', imgListener);
          // imgTags[i].addEventListener('error', imgListener);
        }
      }

      if (self.hasHScroll() === true) {
        zoomCheck(bodyElem);
      }
    }

    self.callOnReady = function() {
      setTimeout(function () {
        // 로딩 직후 처리는 여기에...

        var mode = ['normal'];
        if (self.hasHScroll() === true) {
          mode.push('auto');
        }

        var modeStr = JSON.stringify(mode);
        console.log(' -- Mode list : ', modeStr);

        var success = self.colorMgr.nativeCall('onReady', function (defaultMode) {
            console.log(' -- default Mode : ', defaultMode);
            if (defaultMode !== 'normal') {
              self.checkOption({ mode: 'optimized' });
            } else {
              self.checkOption({ mode: 'normal' });
            }
          },
          [modeStr]);

        if (window.NORMALIZE_MESSAGE_WIDTHS === true || success === false) {
          self.checkOption({ mode: 'optimized' });
        }

        self.isOnReadyCalled = true;
      }, 10);

      var processCopy = function(e, isCut) {
        const selection = document.getSelection();
        e.clipboardData.setData('text/plain', selection.toString());

        if (selection.rangeCount) {
          var rng = selection.getRangeAt(0);

          var cloneFragment = rng.cloneContents();
          var realBody = cloneFragment.querySelector('.mail-message-content');
          if (realBody == null) {
            realBody = cloneFragment;
          }

          var targetElem = document.createElement('body');
          while (realBody.firstChild != null) {
            targetElem.appendChild(realBody.firstChild);
          }

          removePartialZoom(targetElem, false, true);

          var tmpNode = rng.commonAncestorContainer;
          while (tmpNode != null && tmpNode.nodeType == 1 && tmpNode.style.color.length == 0) {
            tmpNode = tmpNode.parentNode;
          }

          if (tmpNode != null && tmpNode.nodeType == 1) {
            var nsc = tmpNode.getAttribute('data-nine-sc');
            var sc = tmpNode.style.color;

            var children = targetElem.children;
            var i;
            for (i = 0; i < children.length; i++) {
              if (children[i].style.color.length == 0) {
                children[i].style.color = sc;
                if (nsc != null) {
                  children[i].setAttribute('data-nine-sc', nsc);
                }
              }
            }
          }

          // ios, safari에서는 img의 url이 사라지는 문제가 발생하여, data-nine-src에 img의 src를 전달하도록 함.
          var imgs = targetElem.querySelectorAll('img');
          for (i = 0; i < imgs.length; i++) {
            var imgSrc = imgs[i].src;
            imgs[i].setAttribute('src', imgSrc);
            imgs[i].setAttribute('data-mce-src', imgSrc);
          }

          // ios, safari에서는 a의 href이 사라지는 문제가 발생하여, data-mce-href에 a의 href를 전달하도록 함.
          var aTags = targetElem.querySelectorAll('a');
          for (i = 0; i < aTags.length; i++) {
            var href = aTags[i].href;
            aTags[i].setAttribute('href', href);
            aTags[i].setAttribute('data-mce-href', href);
          }

          if (self.isDarkMode() == true) {
            editorMgr._restoreElemColor(targetElem);
          }
          e.clipboardData.setData('text/html', targetElem.innerHTML);
        }

        if (isCut === true) {
          selection.deleteFromDocument();
        }
      }

      document.addEventListener('copy', function (e) {
        console.log('copy - ', e);
        processCopy(e, false);
        e.preventDefault();
      });

      document.addEventListener('cut', function (e) {
        console.log('cut - ', e);
        processCopy(e, true);
        e.preventDefault();
      });
    };

    self.lastNotiTime = 0;

    self.notifyResized = function (delayTime) {
      var dTime = delayTime || 500;
      if (self.partialZoomMode == true) {
        if (self.partialZoomTimer != null) {
          clearTimeout(self.partialZoomTimer);
        }
        console.log(' -- notifyResized : ', delayTime, Date.now());
        self.partialZoomTimer = setTimeout(function() {
          self.lastNotiTime = Date.now();
          console.log(' -- Resize~! : ', self.lastNotiTime);
          removePartialZoom();
          setTimeout(function() {
            applyPartialZoom();
          }, 10);
        }, dTime);
      }
    };

    self.setPartialZoom = function (value) {
      if (value == true) {
        if (self.smartViewMode == true) {
          throw new Error('smartView mode is already set.')
        }
        // if (self.hasHScroll() == false) {
        //   throw new Error('No need for partialZoom.')
        // }
      }

      console.log(' - setPartialZoom : ', value);

      if (self.partialZoomMode === value) {
        return;
      }

      self.partialZoomMode = value;

      if (value === true) {
        applyPartialZoom();
      } else {
        removePartialZoom();
      }
    }

    var setActualView = function (value) {
      var bodyElem = document.querySelector('body > .mail-message > .mail-message-content') || document.body;
      if (value === true) {
        var imgTags = bodyElem.querySelectorAll('img');
        for (var i = 0; i < imgTags.length; i++) {
          var imgListenerAS = function (e) {
            self.hasHScroll(); // 스크롤이 발생하는지 확인을 위해 호출 필요.
          };
          imgTags[i].imgListenerAS = imgListenerAS;
          imgTags[i].addEventListener('load', imgListenerAS);
        }
      } else {
        var imgTags = bodyElem.querySelectorAll('img');
        for (i = 0; i < imgTags.length; i++) {
          imgTags[i].removeEventListener('load', imgTags[i].imgListenerAS);
//          imgTags[i].removeEventListener('error', imgTags[i].imgListenerAS);
        }
      }
    }

    self.isOptimizeEnabled = function () {
      mvObj.hasHScroll();
      return self.optimizeEnabled;
    }

    self.setOptimized = function(value) {
      self.setPartialZoom(value);
      // setUIBtnState(value);
      setActualView(!value);
    }

    self.callWebview = function(param) {
      if (self.nfCallback != null) {
        self.nfCallback(param);
      }
    };

    self.isModeEnabled = function() {
      var enabled = self.isOptimizeEnabled();
      setTimeout(function() {
        if (enabled == true) {
          self.callWebview('nine_mode_enabled');
        }
        else {
          self.callWebview('nine_mode_disabled');
        }
      }, 1);
      return enabled;
    };

    self.setMode = function(mode) {
      if (self.isOptimizeEnabled() != true) {
        printLog('no need optimize.');
      } else {
        if (mode == 'optimized') {
          self.setOptimized(true);
        } else {
          self.setOptimized(false);
        }
      }
    };

    self.getMode = function() {
      if (self.isOptimizeEnabled() != true) {
        return 'none';
      }
      else if (self.partialZoomMode == true || self.smartViewMode) {
        return 'optimized';
      } else {
        return 'normal';
      }
    };

    self.checkOption = function(opt) {
      var options = {
        uiBtn: true,
        mode: 'optimized' // 'optimized' or 'normal'
      };

      if (opt != null) {
        if (opt.uiBtn != null) {
          options.uiBtn = opt.uiBtn;
        }

        if (opt.mode != null) {
          options.mode = opt.mode;
        }
      }

      var scriptElem = self.doc.querySelector('script[src*="mailview.js"], script[src*="mailview.min.js"]');

      if (scriptElem != null) {
        var uiBtn = scriptElem.getAttribute('nf-ui-button');
        var mode = scriptElem.getAttribute('nf-mode');

        if (uiBtn != null) {
          options.uiBtn = (uiBtn == 'true');
        }

        if (mode != null && (mode == 'optimized' || mode == 'normal')) {
          options.mode = mode;
        }
      }

      self.setOptions(options);
    };

    window.singleUse = {};

    var editorMgr = {
      darkModeInfo: {
        foreColor: '#ffffff',
        backColor: '#000000'
      },
      _linkColor: {
        link: 'rgb(0, 0, 238)',
        visited: 'rgb(67, 0, 120)'
      },
      _foreColorMap: {},
      _backColorMap: {},
      _foreColorRevMap: {},
      _backColorRevMap: {},
      createSingleUseFunc: function createSingleUseFunc(cb) {
        // 1회용 함수 생성.

        var curTime = Date.now();
        var funcName = 'func' + curTime;
        var idx = 0;

        while (window.singleUse[funcName] != null) {
          funcName = 'func' + curTime + '_' + idx;
        }

        window.singleUse[funcName] = function (param) {
          cb(param);
          delete window.singleUse[funcName];
        };

        return 'singleUse.' + funcName;
      },
      nativeCall: function(funcName, returnCallback, paramArray) {
        if (window.NineNative && NineNative[funcName] != null) {
          try {
            var ret = NineNative[funcName].apply(NineNative, paramArray);
            if (returnCallback != null) {
              returnCallback(ret);
            }
          } catch (e) {
            console.log(e);
            return false;
          }
          return true;
        }
        else if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.nineHandler && window.webkit.messageHandlers.nineHandler.postMessage) {
          var returnFuncName = "";
          if (returnCallback != null) {
            returnFuncName = editorMgr.createSingleUseFunc(returnCallback);
          }
          var param = {
            'function': funcName,
            'returnFunction': returnFuncName,
          };
          if (paramArray != null && paramArray.length > 0) {
            param.params = paramArray;
          }
          var paramStr = JSON.stringify(param);
          window.webkit.messageHandlers.nineHandler.postMessage(paramStr);
          return true;
        }
        return false;
      },
      notifyCreateInvitation: function (startDateStr, endDateStr, displayStr) {
        if (editorMgr._createInvitationTimer != null) {
          clearTimeout(editorMgr._createInvitationTimer);
        }

        editorMgr._createInvitationTimer = setTimeout(() => {
          console.log(' - notifyCreateInvitation - ', startDateStr, endDateStr, displayStr);
          editorMgr.nativeCall( 'createInvitation', null, [startDateStr, endDateStr, displayStr]);
          editorMgr._createInvitationTimer = null;
        }, 300);
      },
      _getHexColor: function(colStr) {
        var crm = null;
        try {
          crm = chroma(colStr); // 정상적인 색상 값이 아니면.. (ex, transparent 등. )
        } catch (e) {
          if (colStr.toLowerCase() == 'transparent') {
            return '#ffffff00';
          }
          return '#808080'
        }
        return crm.hex();
      },
      _getDarkModeColor: function(elem, colStr, isBack) {
        var crm = null;
        var alpha = 1;
        try {
          crm = chroma(colStr); // 정상적인 색상 값이 아니면.. (ex, transparent 등. )
          alpha = crm.alpha();
        } catch (e) {
          if (colStr.toLowerCase() == 'transparent') {
            return '#ffffff00';
          }
          if (isBack === true) {
            return '#000000';
          }
          return '#ffffff';
        }

        var col = crm;
        var lum = crm.luminance();
        var newLum;

        if (lum == 0) { // (isBack === false)
          col = chroma(editorMgr.darkModeInfo.foreColor);
          if (col.alpha() == 0) {
            col = col.alpha(1);
          }
        }
        else if (lum == 1) { // (isBack === true)
          col = chroma(editorMgr.darkModeInfo.backColor);
          if (col.alpha() == 0) {
            col = col.alpha(1);
          }
          if (isBack == true) {
            return col.hex();
          }
        }
            else if (isBack === true) {
          // if (lum < 0.10) {
          //   // var foreLum = editorMgr.darkModeInfo.foreLum;
          //   col = crm.luminance(0.20 - lum);
          // } else if (lum < 0.20) {
          //   // var foreLum = editorMgr.darkModeInfo.foreLum;
          //   col = crm.luminance(0.40 - lum);
          if (lum < 0.01) {
            col = crm;
          } else if (lum < 0.10) {
            col = crm.luminance(lum + 0.10);
          } else if (lum < 0.20) {
            col = crm.luminance(lum + 0.20);
          } else if (lum > 0.75) {
            newLum = 1 - editorMgr.darkModeInfo.backLum - lum;
            newLum = Math.max(newLum, 0);
            col = crm.luminance(newLum);
          }
        } else {
          if (lum < 0.20) {
            // var foreLum = editorMgr.darkModeInfo.foreLum;
            col = crm.luminance(0.5 - lum);
          } else if (lum > 0.90) {
            col = crm.luminance(1.0 - lum);
          } else if (lum > 0.75) {
            newLum = 1 - editorMgr.darkModeInfo.backLum - lum;
            newLum = Math.max(newLum, 0);
            col = crm.luminance(newLum);
          }
        }

        // if (isBack == false) {
          col = col.alpha(alpha);
        // }

        return col.hex();
      },
      _checkElemColor: function(elem, targetCol) {
        // var prop = window.getComputedStyle(elem, null);
        // var foreColor = prop.getPropertyValue('color');
        // var backColor = prop.getPropertyValue('background-color');
        if (editorMgr._foreColorMap['#000000'] == null) {
          var darkCol = editorMgr._getDarkModeColor(null, '#000000', false);
          editorMgr._foreColorMap['#000000'] = darkCol;
          editorMgr._foreColorRevMap[darkCol] = 'rgb(0, 0, 0)';
          editorMgr._backColorMap['#000000'] = darkCol;
          editorMgr._backColorRevMap[darkCol] = 'rgb(0, 0, 0)';
        }

        if (elem != document.body) {

          var foreColor = elem.style.color;
          var backColor = elem.style.backgroundColor;

          var newCol = null;

          if (foreColor != null && foreColor.length > 0 && (targetCol == editorMgr._getHexColor(foreColor) || elem.getAttribute('data-nine-sc') == null)) {
            newCol = editorMgr._getDarkModeColor(elem, foreColor, false);
              if (newCol != foreColor) {
              elem.style.color = newCol;
              editorMgr._foreColorMap[foreColor] = elem.style.color;
              editorMgr._foreColorRevMap[newCol] = foreColor;
              elem.setAttribute('data-nine-sc', foreColor);
            }
          }
          if (backColor != null && backColor.length > 0 && (targetCol == editorMgr._getHexColor(backColor) || elem.getAttribute('data-nine-sb') == null)) {
            newCol = editorMgr._getDarkModeColor(elem, backColor, true);
            if (newCol != null && newCol != backColor) {
              elem.style.backgroundColor = newCol;
              editorMgr._backColorMap[backColor] = elem.style.backgroundColor;
              editorMgr._backColorRevMap[newCol] = backColor;
              elem.setAttribute('data-nine-sb', backColor);
            }
          }
          if (elem.tagName == 'FONT') {
            var fontColor = elem.getAttribute('color');
            if (fontColor != null && fontColor.length > 0 && (targetCol == editorMgr._getHexColor(fontColor) || elem.getAttribute('data-nine-ac') == null)) {
              newCol = editorMgr._getDarkModeColor(elem, fontColor, false);
              if (newCol != null && newCol != fontColor) {
                elem.setAttribute('color', newCol);
                editorMgr._foreColorMap[fontColor] = elem.getAttribute('color');
                editorMgr._foreColorRevMap[newCol] = fontColor;
                elem.setAttribute('data-nine-ac', fontColor);
              }
            }
          }
          if (elem.tagName == 'BODY' || elem.tagName == 'MARQUEE' ||
              elem.tagName == 'TABLE' || elem.tagName == 'THEAD' || elem.tagName == 'TBODY' || elem.tagName == 'TFOOT' ||
              elem.tagName == 'TR' || elem.tagName == 'TH' || elem.tagName == 'TD') {
            var bgColor = elem.getAttribute('bgcolor');
            if (elem == document.body && window._bodyBgColor != null) {
              bgColor = window._bodyBgColor;
            }
            if (backColor == null || backColor.length == 0) {
              if (bgColor != null && bgColor.length > 0 && (targetCol == editorMgr._getHexColor(bgColor) || elem.getAttribute('data-nine-ab') == null)) {
                newCol = editorMgr._getDarkModeColor(elem, bgColor, true);
                if (newCol != null && newCol != bgColor) {
                  elem.removeAttribute('bgcolor');
                  elem.style.backgroundColor = newCol;
                  editorMgr._backColorMap[bgColor] = elem.style.backgroundColor;
                  editorMgr._backColorRevMap[newCol] = bgColor;
                  elem.setAttribute('data-nine-ab', bgColor);
                }
              }
            } else if (bgColor != null && bgColor.length > 0 && (targetCol == editorMgr._getHexColor(bgColor) || elem.getAttribute('data-nine-ab') == null)) {
              newCol = editorMgr._getDarkModeColor(elem, bgColor, true);
              if (newCol != null && newCol != bgColor) {
                elem.setAttribute('bgcolor', newCol);
                editorMgr._foreColorMap[bgColor] = elem.getAttribute('bgcolor');
                editorMgr._foreColorRevMap[newCol] = bgColor;
                elem.setAttribute('data-nine-ab', bgColor);
              }
            }
          }
          if (elem.tagName == 'BLOCKQUOTE') {
            var blc = elem.style.borderLeftColor;
            if (blc != null && blc.length > 0 && (targetCol == editorMgr._getHexColor(blc) || elem.getAttribute('data-nine-blc') == null)) {
              newCol = editorMgr._getDarkModeColor(elem, blc, false);
              if (newCol != null && newCol != blc) {
                elem.style.borderLeftColor = newCol;
                editorMgr._foreColorMap[blc] = elem.style.borderLeftColor;
                editorMgr._foreColorRevMap[newCol] = blc;
                elem.setAttribute('data-nine-blc', blc);
              }
            }
          }

        }

        for (var i = 0; i < elem.children.length; i++) {
          editorMgr._checkElemColor(elem.children[i], targetCol);
        }
      },
      _restoreElemColor: function(elem) {
        var sc = elem.getAttribute('data-nine-sc');
        var sb = elem.getAttribute('data-nine-sb');
        var ac = elem.getAttribute('data-nine-ac');
        var ab = elem.getAttribute('data-nine-ab');
        var blc = elem.getAttribute('data-nine-blc');
        var cssChanged = false;

        if (sc != null) {
          if (editorMgr._foreColorMap[sc] == elem.style.color) { // 색 변화가 없으면 원래 색으로 복원.
            elem.style.color = sc;
            cssChanged = true;
          }
          elem.removeAttribute('data-nine-sc');
        }
        if (sb != null) {
          if (editorMgr._backColorMap[sb] == elem.style.backgroundColor) { // 색 변화가 없으면 원래 색으로 복원.
            elem.style.backgroundColor = sb;
            cssChanged = true;
          }
          elem.removeAttribute('data-nine-sb');
        }
        if (ac != null) {
          if (editorMgr._foreColorMap[ac] == elem.getAttribute('color')) { // 색 변화가 없으면 원래 색으로 복원.
            elem.setAttribute('color', ac);
          }
          elem.removeAttribute('data-nine-ac');
        }
        if (ab != null) {
          var bgColor = elem.getAttribute('bgcolor');
          if (bgColor == null) {
            if (editorMgr._backColorMap[ab] == elem.style.backgroundColor) { // 색 변화가 없으면 원래 색으로 복원.
              elem.style.backgroundColor = '';
              elem.setAttribute('bgcolor', ab);
              cssChanged = true;
            }
          } else if (editorMgr._backColorMap[ab] == bgColor) { // 색 변화가 없으면 원래 색으로 복원.
            elem.setAttribute('bgcolor', ab);
          }
          elem.removeAttribute('data-nine-ab');
        }
        if (blc != null) {
          if (editorMgr._foreColorMap[blc] == elem.style.borderLeftColor) { // 색 변화가 없으면 원래 색으로 복원.
            elem.style.borderLeftColor = blc;
            cssChanged = true;
          }
          elem.removeAttribute('data-nine-blc');
        }

        if (cssChanged == true) {
          elem.setAttribute('style', elem.getAttribute('style'));
        }

        for (var i = 0; i < elem.children.length; i++) {
          editorMgr._restoreElemColor(elem.children[i]);
        }
      },
      _styleTagList: [],
      _processSheet: function (sheet) {
        var ruleListInfo = {
          ruleInfoList: []
        };
        if (sheet != null) {
            for (var i = 0; i < sheet.cssRules.length; i++) {
            var rule = sheet.cssRules[i];
            if (rule.type === 4) {
              var mqRes = editorMgr._processSheet(rule);
              if (mqRes.ruleInfoList.length > 0) {
                var mediaRuleInfo = {
                  queryCondition: rule.media.mediaText,
                  // queryCondition: rule.conditionText,
                  ruleInfoList: mqRes.ruleInfoList,
                  type: 4
                };
                ruleListInfo.ruleInfoList.push(mediaRuleInfo);
              }
            } else if (rule.type === 1) {
              var ruleInfo = {
                selector: rule.selectorText,
                type: 1
              };
              var color = rule.style.color;
              if (color.length > 0 && color !== 'inherit' && color !== 'initial' && color !== 'unset') {
                ruleInfo.color = {
                  value: color,
                  isImportant: rule.style.getPropertyPriority('color') == 'important'
                }
              }
              var backCol = rule.style['background-color'];
              if (backCol.length > 0 && backCol !== 'inherit' && backCol !== 'initial' && backCol !== 'unset') {
                ruleInfo.backCol = {
                  value: backCol,
                  isImportant: rule.style.getPropertyPriority('background-color') == 'important'
                }
              }

              if (ruleInfo.color != null || ruleInfo.backCol != null) {
                ruleListInfo.ruleInfoList.push(ruleInfo);
              }
            }
          }
        }
        // console.log(ruleListInfo);
        return ruleListInfo;
      },
      _getIndent: function(depth) {
        var str = '';
        for (var i = 0; i < depth; i++) {
          str += '  ';
        }
        return str;
      },
      _makeCssText: function(ruleInfo, indent) {
        var str = '';
        if (ruleInfo.type === 1) {
          str += editorMgr._getIndent(indent) + ruleInfo.selector + ' {\n';
          if (ruleInfo.color != null) {
            var color = editorMgr._getDarkModeColor(null, ruleInfo.color.value, false);
            str += editorMgr._getIndent(indent + 1) + 'color: ' + color + ((ruleInfo.color.isImportant != true) ? '' : ' !important') + ';\n'
          }
          if (ruleInfo.backCol != null) {
            var backCol = editorMgr._getDarkModeColor(null, ruleInfo.backCol.value, true);
            str += editorMgr._getIndent(indent + 1) + 'background-color: ' + backCol + ((ruleInfo.backCol.isImportant != true) ? '' : ' !important') + ';\n'
          }
          str += editorMgr._getIndent(indent) + '}\n';
        } else if (ruleInfo.type === 4) {
          str += editorMgr._getIndent(indent) + ruleInfo.queryCondition + ' {\n';
          var ruleText = editorMgr._getStyleText(ruleInfo.ruleInfoList, indent + 1);
          str += ruleText;
          str += editorMgr._getIndent(indent) + '}\n';
        }
        return str;
      },
      _getStyleText: function(ruleInfoList, indent) {
        var str = '';
        for (var i = 0; i < ruleInfoList.length; i++) {
          var txt = editorMgr._makeCssText(ruleInfoList[i], indent);
          str += txt;
        }
        return str;
      },
      _checkStyleTagCss: function(target) {
        editorMgr.darkModeInfo.foreLum = chroma(editorMgr.darkModeInfo.foreColor).luminance();
        editorMgr.darkModeInfo.backLum = chroma(editorMgr.darkModeInfo.backColor).luminance();

        var doc = target || document;
        editorMgr._styleTagList = [];

        var styleTagList = doc.querySelectorAll('style:not(#darkmode-info):not(#ios-css)');
        for (var i = 0; i < styleTagList.length; i++) {
          var sheetInfo = editorMgr._processSheet(styleTagList[i].sheet);
          if (sheetInfo.ruleInfoList.length > 0) {
            var newStyleTag = document.createElement('style');
            newStyleTag.setAttribute('data-nine-style', 'true');
            var cssText = '\n' + editorMgr._getStyleText(sheetInfo.ruleInfoList, 1);
            // console.log(cssText);
            newStyleTag.innerHTML = cssText;
            var styleTagInfo = {
              originTag: styleTagList[i],
              ruleInfoList: sheetInfo.ruleInfoList,
              darkModeTag: newStyleTag
            };
            editorMgr._styleTagList.push(styleTagInfo);
          }
        }

        // var darkmodeTag = doc.querySelector('#darkmode-info');
        // if (darkmodeTag != null) {

        // }

        for (i = 0; i < editorMgr._styleTagList.length; i++) {
          var info = editorMgr._styleTagList[i];

          info.originTag.parentElement.insertBefore(info.darkModeTag, info.originTag.nextSibling);
          // info.originTag.parentElement.appendChild(info.darkModeTag);
        }
      },
      _restoreStyleTagCss: function(target) {
        if (target != null) {
          var styleTagList = target.querySelectorAll('[data-nine-style=true]');
          for (var i = 0; i < styleTagList.length; i++) {
            styleTagList[i].parentElement.removeChild(styleTagList[i]);
          }
        } else {
          for (i = 0; i < editorMgr._styleTagList.length; i++) {
            var info = editorMgr._styleTagList[i];
            info.darkModeTag.parentElement.removeChild(info.darkModeTag);
          }
        }
      }
    }

    self.colorMgr = editorMgr;

    self._nineDarkMode = false;
    self.darkModeApplied = false;

    self.isDarkMode = function() {
      return self._nineDarkMode;
    }

    self.setDarkMode = function(_isDarkMode) {
      if (self._nineDarkMode == _isDarkMode) {
        return;
      }

      self._nineDarkMode = _isDarkMode;

      var savedValue = null;
      var docElem = document.documentElement;
      if (docElem === document.body) {
        docElem = null;
      }

      if (_isDarkMode == true) {

        if (docElem != null && docElem.style.backgroundColor.length > 0) {
          savedValue = docElem.getAttribute('data-nine-ac');
          if (savedValue == null) {
            docElem.setAttribute('data-nine-ac', docElem.style.backgroundColor);
            docElem.style.backgroundColor = 'transparent';
          }
        }

        self.darkModeApplied = true;
        editorMgr.darkModeInfo.backLum = chroma(editorMgr.darkModeInfo.backColor).luminance();
        editorMgr.darkModeInfo.foreLum = chroma(editorMgr.darkModeInfo.foreColor).luminance();

        editorMgr._checkElemColor(document.body);
        self.setDarkBackColor(editorMgr.darkModeInfo.backColor);
        self.setDarkForeColor(editorMgr.darkModeInfo.foreColor);

        editorMgr._checkStyleTagCss(document);
      } else {

        if (docElem != null) {
          savedValue = docElem.getAttribute('data-nine-ac');
          if (savedValue != null) {
            docElem.style.backgroundColor = savedValue;
            docElem.removeAttribute('data-nine-ac');
          }
        }

        editorMgr._restoreElemColor(document.body);
        editorMgr._restoreStyleTagCss(document);
        document.body.style.backgroundColor = '';
        removeDarkForeColor();
      }
    }

    self.applyDarkMode = function() {
      if (self.darkModeApplied == true && self._nineDarkMode == true) {
        editorMgr._restoreElemColor(document.body);
        editorMgr._restoreStyleTagCss(document);
        editorMgr._checkElemColor(document.body);
        editorMgr._checkStyleTagCss(document);
      }
    }

    self.getDarkBackColor = function() {
      return editorMgr.darkModeInfo.backColor;
    }

    self.setDarkBackColor = function(color) {
      editorMgr.darkModeInfo.backColor = color.toLowerCase();
      if (self.isDarkMode() == true) {
        document.body.style.backgroundColor = editorMgr.darkModeInfo.backColor;
      }
    }

    self.getDarkForeColor = function() {
      return editorMgr.darkModeInfo.foreColor;
    }

    self.setDarkForeColor = function(color) {
      editorMgr.darkModeInfo.foreColor = color.toLowerCase();
      if (self.isDarkMode() == true) {
        var doc = document;

        var styleTag = doc.querySelector('#darkmode-info');
        if (styleTag == null) {
          styleTag = doc.createElement('style');
          styleTag.id = 'darkmode-info';
        }
        var cssDec = '\n  body { color: ' + editorMgr.darkModeInfo.foreColor + '; }';

        var linkColor = editorMgr._getDarkModeColor(null, editorMgr._linkColor.link, false);
        var visitedColor = editorMgr._getDarkModeColor(null, editorMgr._linkColor.visited, false);
        cssDec += '\n  a:link { color: ' + linkColor + '; }';
        cssDec += '\n  a:visited { color: ' + visitedColor + '; }';

        cssDec += '\n';

        styleTag.innerHTML = cssDec;

        doc.head.appendChild(styleTag);
      }
    }

    function removeDarkForeColor() {
      var doc = document;
      var styleTag = doc.querySelector('#darkmode-info');

      if (styleTag != null) {
        styleTag.parentElement.removeChild(styleTag);
      }
    }

  }

  window.MailView = MailView;
}

window.isNineApp = function () {
  var userAgent = window.navigator.userAgent;
  if (userAgent.indexOf('NineApp') >= 0) {
    return true;
  }
  return false;
}

window.nineLog = function (msg) {
  location.href = 'nine_log_?'+msg;
}

window.img_find = function () {
  var imgs = document.getElementsByTagName('img');
  var imgSrcs = [];
  for (var i = 0; i < imgs.length; i++) {
    imgSrcs.push(imgs[i].src);
  }
  return imgSrcs;
}

window.reloadInlineImage = function (cid, uri) {
    var i, images, imgCount, orgSrc;

    images = document.getElementsByTagName("img");
    for (i = 0, imgCount = images.length; i < imgCount; i++) {
        image = images[i];

        if (image == null && image.src == null) {
            continue;
        }
        orgSrc = image.src;

        if (orgSrc.indexOf(cid) == 0) {
            image.src = uri;
        }
    }
}

var callWebView = function(param) {
  printLog('call webview - ' + param);
  if (isNineApp() == true) {
    location.href = param;
  }
};

window.setDarkMode = function (backColor, foreColor) {
  if (window.mvObj == null) {
    window._tmpDarkMode = {
      backColor: backColor,
      foreColor: foreColor
    };
  } else {
    window.mvObj.setDarkForeColor(foreColor);
    window.mvObj.setDarkBackColor(backColor);
    window.mvObj.applyDarkMode();
    window.mvObj.setDarkMode(true);
  }
};

function initMV(isLoadedState) {
  if (document.body.style.visibility == 'hidden') {
    // bgcolor가 있으면 IOS 깜박임이 나타남. body의 bgcolor를 저장해 놓고 darkmode 색을 계산할 때는 저장된 값을 불러다 쓰도록 처리함.
    window._bodyBgColor = document.body.getAttribute('bgcolor');
    document.body.removeAttribute('bgcolor');
  }

  var mvObj = new MailView(document, callWebView);

  // if (mvObj.doc.head.querySelector('meta[name=viewport]') == null) {
  mvObj.setViewMetaTag(true);
  // }

  mvObj.setDefaultCSS();
  mvObj.checkEditableElem();

  window.mvObj = mvObj;

  if (window._tmpDarkMode != null) {
    window.mvObj.setDarkForeColor(window._tmpDarkMode.foreColor);
    window.mvObj.setDarkBackColor(window._tmpDarkMode.backColor);
    window.mvObj.setDarkMode(true);
  }

  // @todo 개발 방향.
  // optimized => smartView 로 이름 변경.
  // hasHScroll 함수 구현 - hscroll이 없으면 auto모드는 사용할 필요없음.
  // auto 모드는 optimized와 partial zoom으로 구분됨. (optimized는 사용하지 않을 예정이므로 기능 분리 필요.)
  // optimized모드는 hasMediaQuery 가 true이면 사용하지 못함.
  // 기본으로 checkHScroll과 checkMediaQuery는 기본으로 호출되어야 하고, 호출 직후에 native와 사용가능한 mode를 주고받아야 함.
  // optimized와 partial zoom - 구분하여 구현하자~!!

  // setTimeout(function () {
  //   // 로딩 직후 처리는 여기에...

  //   var mode = ['normal'];
  //   if (mvObj.hasHScroll() === true) {
  //     mode.push('auto');
  //   }

  //   var modeStr = JSON.stringify(mode);
  //   console.log(' -- Mode list : ', modeStr);

  //   var success = mvObj.colorMgr.nativeCall('onReady', function (defaultMode) {
  //       console.log(' -- default Mode : ', defaultMode);
  //       if (defaultMode !== 'normal') {
  //         mvObj.checkOption({ mode: 'optimized' });
  //       }
  //     },
  //     [modeStr]);

  //   if (window.NORMALIZE_MESSAGE_WIDTHS === true || success === false) {
  //     mvObj.checkOption({ mode: 'optimized' });
  //   }

  //   mvObj.isOnReadyCalled = true;
  // }, 10);


  // img 태그에 click 이벤트 추가.
  // var imgTags = document.querySelectorAll('img');
  // for (var i = 0; i < imgTags.length; i++) {
  //   imgTags[i].addEventListener('click', function(evt) {
  //     if (evt.target.parentElement.tagName.toLowerCase() != 'a') {
  //       location.href = 'nine_zoom_?' + evt.target.src;
  //     }
  //   });
  // }

  var lastHeight = 0;
  var timerH = null;

  var notifyResize = function() {
    if (window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.sizeNotification) {
      window.webkit.messageHandlers.sizeNotification.postMessage({width: document.body.scrollWidth, height: document.body.scrollHeight});
    }
  };

  var checkResizeEnabled = false;
  var checkResize = function() {
    if (checkResizeEnabled == false) {
      checkResizeEnabled = true;
      window.addEventListener('resize', function(e) {
        printLog('resized - ', e);
        checkHeight(false, true);
      });
    }
  };

  var checkHeight = function(forced, isResize) {
    if (timerH != null) {
      clearTimeout(timerH);
    }
    timerH = setTimeout(function() {
      timerH = null;
      var newHeight = document.documentElement.scrollHeight;
      // @todo - partial zoom 재설정.. 추가하자.
      if (isResize == true) {
        mvObj.notifyResized();
      }
      printLog('check height - ' + newHeight);
      if (lastHeight == newHeight) {
        mvObj.setBodyVisible(true); // 일정 시간 간격으로 검사하여 Height의 변화가 없으면 화면이 보이도록 처리.
        if (forced == true) {
          printLog('new rendering');
          document.body.style.display = 'none';
          setTimeout(function() {
            document.body.style.display = '';
          }, 10);
        }
        mvObj.callWebview('nine_rendering_finished'); // - 더 이상 높이 변화가 없는 상태입니다.
        notifyResize();
        checkResize();
      } else {
        lastHeight = newHeight;
        checkHeight(false, false);
      }
    }, 300/*unit:ms*/);
  };

  window.mvObj.checkHeight = checkHeight;

  if (isLoadedState == true) {
    lastHeight = document.documentElement.scrollHeight;
    printLog('lastHeight - ' + lastHeight);
    mvObj.callOnReady();
    checkHeight(false, false);
  } else {
    var timerForLoading = setTimeout(function() {
      printLog('window load - timeout');
      lastHeight = document.documentElement.scrollHeight;
      printLog('height - ' + lastHeight);
      mvObj.callOnReady();
      checkHeight(true, false);
    }, 1000/*ms*/);  // 여기 숫자를 수정하면 대기 시간을 조정할 수 있습니다. (1000ms)

    window.addEventListener('load', function() {
      clearTimeout(timerForLoading);
      printLog('window load');
      lastHeight = document.documentElement.scrollHeight;
      printLog('lastHeight - ' + lastHeight);
      mvObj.callOnReady();
      checkHeight(false, false);
    });
  }

  document.addEventListener('click', function(e) {
    var tbody = null;
    var item = null;
    var target = e.target;
    do {
      tbody = target.closest('tbody');
      if (tbody != null) {
        item = tbody.querySelector('[itemscope][itemprop="option"]');
        target = tbody.parentElement;
      }
    } while (target != null && tbody != null && item == null)

    if (item != null && tbody === item.parentElement) {
      var itemType = item.getAttribute('itemtype');
      if (itemType === 'http://schema.org/Event') {
        var displayStr = item.innerText.trim();
        var startElem = item.querySelector('time[itemprop="startDate"]');
        var endElem = item.querySelector('time[itemprop="endDate"]');
        if(startElem != null && endElem != null) {
          var startDate = startElem.getAttribute('datetime');
          var endDate = endElem.getAttribute('datetime');
          if (startDate != null && endDate != null) {
            mvObj.colorMgr.notifyCreateInvitation(startDate, endDate, displayStr);
            return;
          }
        }
      }
    }

    tbody = e.target.closest('input[value="itemtype-event"] + form');

    if (tbody != null) {
      startElem = tbody.querySelector('input[type="hidden"]:nth-of-type(1)');
      endElem = tbody.querySelector('input[type="hidden"]:nth-of-type(2)');
      if(startElem != null && endElem != null) {
        displayStr = tbody.innerText.trim();
        startDate = startElem.getAttribute('value');
        endDate = endElem.getAttribute('value');
        if (startDate != null && endDate != null) {
          mvObj.colorMgr.notifyCreateInvitation(startDate, endDate, displayStr);
          return;
        }
      }
    }
  });
}

printLog('first readyState - ' + document.readyState);

if (document.readyState == 'complete' || document.readyState == 'interactive') {
  printLog('readyState - complete');
  initMV(document.readyState == 'complete');
} else {
  document.addEventListener('DOMContentLoaded', function() {
    printLog('DOMContentLoaded.');
    initMV(false);
  });
}

var uiWebview_SearchResultCount = 0;
var uiWebview_foreColor = 'black';
var uiWebview_backColor = 'yellow';

/*!
 @method     uiWebview_HighlightAllOccurencesOfStringForElement
 @abstract   // helper function, recursively searches in elements and their child nodes
 @discussion // helper function, recursively searches in elements and their child nodes

 element    - HTML elements
 keyword    - string to search
 */

function uiWebview_HighlightAllOccurencesOfStringForElement(element, keyword) {
  if (element) {
    if (element.nodeType == 3) {
      // Text node

      var count = 0;
      var elementTmp = element;
      while (true) {
        var value = elementTmp.nodeValue; // Search for keyword in text node
        var idx = value.toLowerCase().indexOf(keyword);

        if (idx < 0) break;

        count++;
        elementTmp = document.createTextNode(
          value.substr(idx + keyword.length)
        );
      }

      uiWebview_SearchResultCount += count;

      var index = uiWebview_SearchResultCount;
      while (true) {
        var value = element.nodeValue; // Search for keyword in text node
        var idx = value.toLowerCase().indexOf(keyword);

        if (idx < 0) break; // not found, abort

        //we create a SPAN element for every parts of matched keywords
        var span = document.createElement("span");
        var text = document.createTextNode(value.substr(idx, keyword.length));
        span.appendChild(text);

        span.setAttribute("class", "uiWebviewHighlight");
        span.style.backgroundColor = uiWebview_backColor;
        span.style.color = uiWebview_foreColor;

        index--;
        span.setAttribute("id", "SEARCH WORD" + index);
        //span.setAttribute("id", "SEARCH WORD"+uiWebview_SearchResultCount);

        //element.parentNode.setAttribute("id", "SEARCH WORD"+uiWebview_SearchResultCount);

        //uiWebview_SearchResultCount++;    // update the counter

        text = document.createTextNode(value.substr(idx + keyword.length));
        element.deleteData(idx, value.length - idx);

        var next = element.nextSibling;
        //alert(element.parentNode);
        element.parentNode.insertBefore(span, next);
        element.parentNode.insertBefore(text, next);
        element = text;
      }
    } else if (element.nodeType == 1) {
      // Element node
      if (
        element.style.display != "none" &&
        element.nodeName.toLowerCase() != "select"
      ) {
        for (var i = element.childNodes.length - 1; i >= 0; i--) {
          uiWebview_HighlightAllOccurencesOfStringForElement(
            element.childNodes[i],
            keyword
          );
        }
      }
    }
  }
}

// the main entry point to start the search
function uiWebview_HighlightAllOccurencesOfString(keyword, fColor, bColor) {
  if (fColor != null) {
    uiWebview_foreColor = fColor;
  }
  if (bColor != null) {
    uiWebview_backColor = bColor;
  }
  uiWebview_RemoveAllHighlights();
  uiWebview_HighlightAllOccurencesOfStringForElement(
    document.body,
    keyword.toLowerCase()
  );
}

// helper function, recursively removes the highlights in elements and their childs
function uiWebview_RemoveAllHighlightsForElement(element) {
  if (element) {
    if (element.nodeType == 1) {
      if (element.getAttribute("class") == "uiWebviewHighlight") {
        var text = element.removeChild(element.firstChild);
        element.parentNode.insertBefore(text, element);
        element.parentNode.removeChild(element);
        return true;
      } else {
        var normalize = false;
        for (var i = element.childNodes.length - 1; i >= 0; i--) {
          if (uiWebview_RemoveAllHighlightsForElement(element.childNodes[i])) {
            normalize = true;
          }
        }
        if (normalize) {
          element.normalize();
        }
      }
    }
  }
  return false;
}

// the main entry point to remove the highlights
function uiWebview_RemoveAllHighlights() {
  uiWebview_SearchResultCount = 0;
  uiWebview_RemoveAllHighlightsForElement(document.body);
}

function uiWebview_ScrollTo(idx) {
  var scrollTo = document.getElementById("SEARCH WORD" + idx);
  if (scrollTo) scrollTo.scrollIntoView();
}
